﻿using System;
using System.Linq;
using System.Web;
using System.Collections.Specialized;
using System.Net;
using System.IO;
using Cart = eegscreening.Models.ViewModels.Cart;
using Order = eegscreening.Models.DB.Order;


namespace eegscreening.Models.ObjectManager
{
     public class PayPal
          
     {
          public static PayPalRedirect ExpressCheckout(Order order, Cart carts)
          {
               var values = new NameValueCollection();
               
               values["METHOD"] = "SetExpressCheckout";
               values["RETURNURL"] = PayPalSettings.ReturnUrl;
               values["CANCELURL"] = PayPalSettings.CancelUrl;
               values["AMT"] = order.Total.ToString("0.00");
               values["ACTION"] = "Sale";
               values["CURRENCYCODE"] = "USD";
               values["USER"] = PayPalSettings.Username;
               values["PWD"] = PayPalSettings.Password;
               values["SIGNATURE"] = PayPalSettings.Signature;
               values["DESC"] = "EEG Screening Review";
               values["VERSION"] = "2.3";
               
               values = Submit(values);

               string ack = values["ACK"].ToLower();

               if (ack == "success" || ack == "successwithwarning")
               {
                    return new PayPalRedirect
                                {
                                     Token = values["TOKEN"],
                                     Url = String.Format("https://{0}/cgi-bin/webscr?cmd=_express-checkout&token={1}", PayPalSettings.CgiDomain, values["TOKEN"])
                                };
               }
               throw new Exception(values["L_LONGMESSAGE0"]);
          }

         private static NameValueCollection Submit(NameValueCollection values)
          {
               string data = String.Join("&", values.Cast<string>()
                                                   .Select(key => String.Format("{0}={1}", key, HttpUtility.UrlEncode(values[key]))));

               var request = (HttpWebRequest)WebRequest.Create(
                    String.Format("https://{0}/nvp", PayPalSettings.ApiDomain));

               request.Method = "POST";
               request.ContentLength = data.Length;

               using (var writer = new StreamWriter(request.GetRequestStream()))
               {
                    writer.Write(data);
               }

               using (var reader = new StreamReader(request.GetResponse().GetResponseStream()))
               {
                    return HttpUtility.ParseQueryString(reader.ReadToEnd());
               }
          }


          
     }
         public class PayPalRedirect
     {
          public string Url { get; set; }
          public string Token { get; set; }
     }
         public class PayPalOrder
     {
          public decimal Amount { get; set; }
     }


}